/* functions for communicating with one or more pololu sscs over a serial port */

typedef struct ssc {
  int connected; /* if not true, connect() must be run */
  int fd; /* File descriptor for the port */
  char idstring[26];
} ssc;

/* (re)connect to the motor
   returns true if a successful new connection is made */
extern int connectSsc(ssc *s);

/* returns the ssc to the origin and closes the connection */
extern void endSession(ssc *s);

/* gets the ID of this ssc */
const char *getId(ssc *s);

/* step to position <pos> on servo <servo> of controller <controller> */
int stepTo(ssc *s, int controller, int servo, int pos);

/* enable/disable servo <servo> of controller <controller> */
int enable(ssc *s, int controller, int servo, int enabled);



