#include <tk.h>
#include "ssc.h"

ssc s;

int killProc(ClientData clientData, Tcl_Interp *interp,
       int objc, Tcl_Obj *CONST objv[]) {

  endSession(&s);
  return TCL_OK;
}

int stepToProc(ClientData clientData, Tcl_Interp *interp,
       int objc, Tcl_Obj *CONST objv[]) {
  int pos;
  int servo;
  int controller;
  static char buf[100];

  if(objc == 4) {
    Tcl_GetIntFromObj(interp, objv[1], &controller);
    Tcl_GetIntFromObj(interp, objv[2], &servo);
    Tcl_GetIntFromObj(interp, objv[3], &pos);
    if(stepTo(&s,controller,servo,pos)) {
      return TCL_OK;
    } else {
      snprintf(buf,100,"step to %d out of bounds",pos);
      Tcl_SetResult(interp,buf,TCL_STATIC);
      return TCL_ERROR;
    }
  } else {
    Tcl_SetResult(interp,"format error",TCL_VOLATILE);
    return TCL_ERROR;
  }

}

int enableProc(ClientData clientData, Tcl_Interp *interp,
       int objc, Tcl_Obj *CONST objv[]) {
  int enabled;
  int servo;
  int controller;
  static char buf[100];

  if(objc == 4) {
    Tcl_GetIntFromObj(interp, objv[1], &controller);
    Tcl_GetIntFromObj(interp, objv[2], &servo);
    Tcl_GetBooleanFromObj(interp, objv[3], &enabled);
    enable(&s,controller,servo,enabled);
    return TCL_OK;
  } else {
    Tcl_SetResult(interp,"format error",TCL_VOLATILE);
    return TCL_ERROR;
  }

}

int connectProc(ClientData clientData, Tcl_Interp *interp,
  int objc, Tcl_Obj *CONST objv[]) {
  static int i=0;
  static char buf[100];

  i++;
  if(connectSsc(&s)) {
    snprintf(buf,100,"connected to %s",getId(&s));
    Tcl_SetResult(interp,buf,TCL_STATIC);
    return TCL_OK;
  } else {
    Tcl_SetResult(interp,"not connected",TCL_VOLATILE);
    return TCL_ERROR;
  }
}

int Ssctester_Init(Tcl_Interp *interp) {
  Tcl_CreateObjCommand(interp, "connect", &connectProc, NULL, NULL);
  Tcl_CreateObjCommand(interp, "kill", &killProc, NULL, NULL);
  Tcl_CreateObjCommand(interp, "stepTo", &stepToProc, NULL, NULL);
  Tcl_CreateObjCommand(interp, "enable", &enableProc, NULL, NULL);
  return TCL_OK;
}
